//*****************************************************************************
//!
//! @file $Id: test_halt.c 804 2008-02-20 09:09:20Z raubree $
//!
//! Copyright (c) 2008 Atmel.
//!
//! @brief 啔 : ͂ł̌@\@
//!
//! @todo
//! @bug
//*****************************************************************************

//_____ ݸٰ _______________________________________________________________

#include "gcc_compiler.h"
#include <avr/io.h>

#include "pll_drv.h"

#include "psc_drv.h"

#define TEST_FILTER
#ifdef TEST_FILTER
  #define A_SA_VAL	5
  #define A_RA_VAL	25
  #define A_SB_VAL	30

  #define B_SA_VAL	5
  #define B_RA_VAL	25
  #define B_SB_VAL	30

  #define C_SA_VAL	5
  #define C_RA_VAL	25
  #define C_SB_VAL	30

  #define RB_VAL	40
#else
  #define A_SA_VAL	5
  #define A_RA_VAL	75
  #define A_SB_VAL	65

  #define B_SA_VAL	110
  #define B_RA_VAL	80
  #define B_SB_VAL	115

  #define C_SA_VAL	60
  #define C_RA_VAL	80
  #define C_SB_VAL	90

  #define RB_VAL	125
#endif

/* Ȃg̉pɒ`ĂB */
#define PSC_PRESCALER			PSC_NODIV_CLOCK
#define PSC_CLOCK_SOURCE		PSC_CLOCK_SOURCE_EQ_PLL

#define PSC_MODE				PSC_MODE_ONE_RAMP

#define PSC_OUTPUT_B_POLARITY	PSC_OUTPUT_HIGH
#define PSC_OUTPUT_A_POLARITY	PSC_OUTPUT_HIGH

 /* ~`Ԃނ񊈓`Ԃɂ͎̍s𒍎߂ɂĂB */
//#define PSC_TEST_HALT

/*F**************************************************************************
* NAME: PSC
*****************************************************************************/
void psc_init (void)
{
  Psc_enable_all_outputs();							// PSCSo͋

  Psc_set_module_A(A_SA_VAL,A_RA_VAL,A_SB_VAL);		// PSC0rl
  Psc_set_module_B(B_SA_VAL,B_RA_VAL,B_SB_VAL);		// PSC1rl
  Psc_set_module_C(C_SA_VAL,C_RA_VAL,C_SB_VAL);		// PSC2rl
  Psc_set_register_RB(RB_VAL);						// ʔrl

  Psc_config();										// PSC`Ԑݒ
#ifdef PSC_TEST_HALT
  Psc_config_input_0(PSC_OVERLAP_DISABLE,\
					 PSC_USE_PIN,\
					 PSC_USE_LOW_LEVEL,\
					 PSC_INPUT_FILTER_ENABLE,\
					 PSC_SYNCHRONOUS_OUTPUT_CONTROL,\
					 PSC_INPUT_HALT);
#else				/* o͋֎~`Ԏ */
   Psc_config_input_0(PSC_OVERLAP_DISABLE,\
					 PSC_USE_PIN,\
					 PSC_USE_HIGH_LEVEL,\
					 PSC_INPUT_FILTER_DISABLE,\
					 PSC_SYNCHRONOUS_OUTPUT_CONTROL,\
					 PSC_DISACTIVATE_OUTPUT_A);
#endif

   Psc_run();										// PSCs
}

/*F**************************************************************************
* NAME: main
*****************************************************************************/
int main (void)
{
  Start_pll_64_mega();								// PLL 64MHzn
  Wait_pll_ready();									// PLLҋ@
  psc_init();										// PSC

  PORTC = 0xFF;
  DDRC = 0xFF;

  while(1)
  {
	if (bit_is_clear(PINE,PINE2))					// PE2(SW1)=LŁA
	{
	  while (bit_is_clear(PINE,PINE2));				// PE2(SW1)Jҋ@
	  Psc_run();									// PSCs
	}
  }
}
