//*****************************************************************************
//!
//! @file $Id: OneRampMode 804 2008-02-20 09:09:20Z raubree $
//!
//! Copyright (c) 2008 Atmel.
//!
//! @brief 啔 : 1XΓPSC6̔g`𐶐
//!					6̔g`6PSCo͂ŗp\łB
//! @todo
//! @bug
//*****************************************************************************

//_____ ݸٰ _______________________________________________________________
#include "gcc_compiler.h"
#include <avr/io.h>

#include "pll_drv.h"
#include "psc_drv.h"

//_____ ` __________________________________________________________________

//#define T_OVERLAP			/* T_OVERLAP : dl̐ݒI */

#define T_HIGH_VALUES

#ifdef T_OVERLAP

#define A_SA_VAL	25
#define A_RA_VAL	75
#define A_SB_VAL	50

#define B_SA_VAL	25
#define B_RA_VAL	75
#define B_SB_VAL	50

#define C_SA_VAL	20
#define C_RA_VAL	40
#define C_SB_VAL	60

#define RB_VAL		100

#else

#ifdef T_HIGH_VALUES

#define A_SA_VAL	250
#define A_RA_VAL	400
#define A_SB_VAL	750

#define B_SA_VAL	800
#define B_RA_VAL	1100
#define B_SB_VAL	1150

#define C_SA_VAL	600
#define C_RA_VAL	800
#define C_SB_VAL	900

#define RB_VAL		1250

#else

#define A_SA_VAL	25
#define A_RA_VAL	40
#define A_SB_VAL	75

#define B_SA_VAL	80
#define B_RA_VAL	110
#define B_SB_VAL	115

#define C_SA_VAL	60
#define C_RA_VAL	80
#define C_SB_VAL	90

#define RB_VAL		125

#endif

#endif

/* Ȃ̉pŌ`Ԑݒ肵ĂB */
#define PSC_PRESCALER			PSC_NODIV_CLOCK
#define PSC_CLOCK_SOURCE		PSC_CLOCK_SOURCE_EQ_PLL

#define PSC_MODE				PSC_MODE_ONE_RAMP

#define PSC_OUTPUT_B_POLARITY	PSC_OUTPUT_HIGH
#define PSC_OUTPUT_A_POLARITY	PSC_OUTPUT_HIGH

/*F**************************************************************************
* NAME: PSC
*****************************************************************************/
void PSC_Init (void)
{
  Psc_enable_all_outputs();							// PSCSo͋

  Psc_set_module_A(A_SA_VAL,A_RA_VAL,A_SB_VAL);		// PSC0rl
  Psc_set_module_B(B_SA_VAL,B_RA_VAL,B_SB_VAL);		// PSC1rl
  Psc_set_module_C(C_SA_VAL,C_RA_VAL,C_SB_VAL);		// PSC2rl
  Psc_set_register_RB(RB_VAL);						// ʔrl

  Psc_config();										// PSC`Ԑݒ
#ifdef T_OVERLAP
  Psc_config_input_0(PSC_OVERLAP_ENABLE,\
					 PSC_INPUT_SELECT_PSCIN,\
					 PSC_INPUT_LOW_LEVEL,\
					 PSC_INPUT_FILTER_ENABLE,\
					 PSC_INPUT_ASYNCHRONOUS,\
					 PSC_INPUT_NO_ACTION);

  Psc_config_input_1(PSC_OVERLAP_DISABLE,\
					 PSC_INPUT_SELECT_PSCIN,\
					 PSC_INPUT_LOW_LEVEL,\
					 PSC_INPUT_FILTER_ENABLE,\
					 PSC_INPUT_ASYNCHRONOUS,\
					 PSC_INPUT_NO_ACTION);
#endif
   Psc_run();										// PSCs
}

/*F**************************************************************************
* NAME: main
*****************************************************************************/
int main (void)
{
  Start_pll_64_mega();		// PLL 64MHzn
  Wait_pll_ready();			// PLLҋ@
  PSC_Init();				// PSC
  while(1) {;}
}
